function [surfaceArea] = SA_Calculation(binaryMatrix)
    % Create a structuring element for 26-connected neighbors
    se = strel('cuboid', [3, 3, 3]); % You can adjust the size as needed
    
    % Erode the binary matrix with the structuring element
    erodedMatrix = imerode(binaryMatrix, se);
    
    % Calculate the surface area as the difference between the original and eroded volumes
    surfaceArea = sum(binaryMatrix(:)) - sum(erodedMatrix(:));
end