function [ReactMap] = reactivity_map(const_b,curva,unq_curvature,init_vol)
% [curva] = distance_map(init_vol,init_curvature,unq_curvature);
[xv,yv,zv] = findND(init_vol == 1);

%% Obtaining the constant from the empirical model
const = zeros(size(unq_curvature,1),1);
const_curv = zeros(size(unq_curvature,1),1);
const_val = zeros(size(unq_curvature,1),1);
a=1;
for i=1:size(const_b,1)
    if const_b(i,3) >= 0
        const_curv(a,1) = const_b(i,1);
        const_val(a,1) = const_b(i,2);
        a=a+1;
    end
end

%% Extract linear correlation
ft = fittype( 'poly1' );
[fitresult,~] = fit(const_curv,const_val,ft);
y = @(x) fitresult.p1*x + fitresult.p2;

for i=1:size(unq_curvature,1)
    const(i) = y(unq_curvature(i));
end

% for i=1:size(unq_curvature,1)
%     [x,~] = find(const_b(:,1)==unq_curvature(i));
%     if size(x,1) ~= 0
%         const(i) = const_b(x,2);
%     else
%         if sign(unq_curvature(i)) == -1
%             % for j=2:size(const_b,1)
%             %     if unq_curvature(i) > const_b(j-1,1) && unq_curvature(i) < const_b(j,1)
%             %         idx = j;
%             %     else
%             %         idx = 0;
%             %     end
%             % end
%         elseif sign(unq_curvature(i)) == 1
%         % if sign(unq_curvature(i)) == 1
%             for j=2:size(const_b,1)
%                 if unq_curvature(i) < const_b(j-1,1) && unq_curvature(i) > const_b(j,1)
%                     idx = j;
%                 else
%                     idx = 0;
%                 end
%             end
%         end
% 
%         if idx ~= 0
%             const(i) = (unq_curvature(i)-const_b(idx,1))/(const_b(idx+1,1)-const_b(idx,1))*(const_b(idx+1,2) - const_b(idx,2)) + const_b(idx,2);
%         else
%             const(i) = (unq_curvature(i)-min(const_b(:,1)))/(max(const_b(:,1))-min(const_b(:,1)))*(max(const_b(:,2)) - min(const_b(:,2))) + min(const_b(:,2));
%         end
%     end
% end

%% Creating reactivity map based on curvature values and distance for each curvature
% disp('     - Creating reactivity map');
ReactMap = zeros(size(init_vol));
nn = size(curva,2);
n_xv = size(xv,1);
for i=1:nn % Bringing up each curvature values
    for j=1:n_xv % Iterating all over the particle surfaces
        ReactMap(xv(j),yv(j),zv(j)) = ReactMap(xv(j),yv(j),zv(j)) + exp(-const(i)*curva(i).init_dist(xv(j),yv(j),zv(j)));
    end
end
end